using System.Diagnostics;
using System.Numerics;
using System.Reflection.Metadata;
using System.Runtime.InteropServices;

namespace OpenGLTest
{
    public partial class Form1 : Form
    {
        const string DllPath = "OpenGLRenderer.dll"; // Name of your C++ DLL

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void GLErrorCallbackDelegate(uint errorCode, [MarshalAs(UnmanagedType.LPStr)] string errorMessage);

        [DllImport(DllPath, CallingConvention = CallingConvention.Cdecl)]
        public static extern uint InitializeOpenGL(nint hWND);

        [DllImport(DllPath, CallingConvention = CallingConvention.Cdecl)]
        public static extern uint RenderFrame();

        [DllImport(DllPath, CallingConvention = CallingConvention.Cdecl)]
        public static extern uint SetErrorCallback(GLErrorCallbackDelegate errorCallbackDelegate);

        public Form1()
        {
            InitializeComponent();
            SetErrorCallback(HandleError);
        }

        private static void HandleError(uint errorCode, string errorMessage)
        {
            Console.WriteLine($"Error: {errorMessage}");
            // Handle the error as needed in your application
        }

        private void button1_Click(object sender, EventArgs e)
        {
            nint handle = panel1.Handle;

            uint error;
            error = InitializeOpenGL(panel1.Handle);
            RenderFrame();
            this.Invalidate();
        }
    }
}